#ifndef TwoD_SOR
#define TwoD_SOR

/* Global variables. */
int n, t, rowsPerThread;
float **val, **new;
int iterations = 0;
float threshold = 0.0;
float delta = 0.0;
int iterates = 0;


/* define two helper functions */
double Abs(double x)
{
   if(x < 0) x = -x;
   return x;
}

double Max(double x, double y)
{
   if(x >= y)
      return x;
   else
      return y;
}


/* write "binary data" to a "raw" image file */
/* a "raw" image file can be opened by IrfanView */
void WriteData(char* fileName, float **a)
{
   FILE* fp;
   unsigned char gray;
   int i, j;
   if( !(fp = fopen(fileName, "wb")) )
      printf("fopen error: cannot open %s\n", fileName);
   else
      for (i = 0; i < n; i++)
         for (j = 0; j < n; j++)
         {
            gray = (char)(a[i][j]*255);
            fwrite(&gray, sizeof(char), 1, fp);
         }
   fclose(fp);
}/* WriteData() */

#endif  /* TwoD_SOR */